unit UCombination;

interface

uses Classes, SysUtils, Forms, ComCtrls;

function Slove(M:Integer; Lines:TStrings; Check:Boolean; ProgBar:TProgressBar):Integer;

implementation

type TMas=array of Integer;

procedure GetFirst(var C:TMas); //   
var i:Integer;
begin
  for i:=1 to Length(C)-1 do
    C[i]:=0;
end;

function GetNext(var C:TMas):Boolean;  //  
var i:Integer;
begin
  i:=Length(C)-1;
  while (i>=0) and (C[i]=1) do
    begin
      C[i]:=0;
      Dec(i);
    end;
  if i<0 then
    Result:=false
  else
     begin
        C[i]:=1;
        Result:=true
     end;
end;

function SkalMult(var C,DP:TMas; ProgBar:TProgressBar):Integer; //  
var i:integer;
begin
  Result:=0;
  for i:=0 to (Length(C)-1) do
    begin
      Result:=Result + C[i]*DP[i];
      ProgBar.Position:=ProgBar.Position+1;
      ProgBar.Max:=ProgBar.Max+5;
    end;
end;

procedure InitMas(M:Integer; var D,P,DP:TMas; Check:Boolean);  // 
const MaxK=81;
var k,dd,pp,st:Integer;
begin
  SetLength(D,MaxK);
  SetLength(P,MaxK);
  SetLength(DP,MaxK);

  k:=0;
  D[k]:=1;
  P[k]:=1;
  DP[k]:=1;

  for dd:=2 to 9 do
    begin
      st:=1;
      pp:=0;

      if Check then
        repeat            //  
          Inc(k);
          P[k]:=pp;
          D[k]:=dd;
          DP[k]:=st;
          Inc(pp);
          st:=st*dd;
        until (pp>9) or (st>M)
      else
        repeat            //  
          Inc(pp);
          st:=st*dd;
          if st<=M then
            begin
              Inc(k);
              P[k]:=pp;
              D[k]:=dd;
              DP[k]:=st;
            end;
        until (pp=9) or (st>M);
    end;

  SetLength(D,k+1);
  SetLength(P,k+1);
  SetLength(DP,k+1);

end;

function CombinationToStr(var D,P,C:TMas; M:Integer):string; // 
var i:Integer;
begin
  Result:=IntToStr(M)+'=';
  for i:=0 to (Length(C)-1) do
    if C[i]>0 then
      Result:=Result+IntToStr(D[i])+'^'+IntToStr(P[i])+'+';
  SetLength(Result,length(Result)-1);
end;

function Slove(M:Integer; Lines:TStrings; Check:Boolean; ProgBar:TProgressBar):Integer; // 
var D,P,DP,C:TMas;
begin
  InitMas(M,D,P,DP,Check);
  SetLength(C,Length(D));
  Result:=0;
  GetFirst(C);
  while GetNext(C) do
    if SkalMult(C,DP,ProgBar)=M then
        begin
          Inc(Result);
          Lines.Add(CombinationToStr(D,P,C,M));
          Application.ProcessMessages;
        end;
  ProgBar.Max:=ProgBar.Position;
end;

end.
